/*-------------------------------------------------------------
  module: vand.C
  author: Angel L. Diaz
  date: 10/23/96

-------------------------------------------------------------*/

// arithmetic includes
#include "PlugIns/saclib.h"
#include "BlackBox/CommonObjects/bbvandermonde.h"


int main() {
   Word stack;
   SaclibInitEnv(1000000,stack);

   int NumVars  = 6;
   int Deg      = -1;
   int Prob     = 1;
   int UsedVars = 3;
   BlackBoxVandDet< SaclibQ > BBVandDet1( NumVars, Deg, Prob, 
      UsedVars );

   SaclibQ T1[6] = { (long)1, (long)2, (long)3, (long)4, (long)5, (long)6 };
   cout << "BBVandDet1( T1 ) = " << *BBVandDet1( T1 ) << endl;

   int StartPnt = 3;
   int EndPnt   = 6;
   BlackBoxVandDet< SaclibQ > BBVandDet2( NumVars, Deg, Prob,
      UsedVars, StartPnt, EndPnt, BBDEFS_TRUE );

   cout << "BBVandDet2( T1 ) = " << *BBVandDet2( T1 ) << endl;

   SaclibCleanUpEnv();
}

