
/*-------------------------------------------------------------
  module: bbdefs.h
  author: Angel L. Diaz

  date: 10/28/96

  description: 
     Definitions and includes common to all black box library routines

  (c) Copyright 1996 Angel Diaz and Erich Kaltofen, All Rights Reserved
  This code is provided WITHOUT WARRANTY either expressed or implied.

-------------------------------------------------------------*/

#ifndef _BBDEFS
#define _BBDEFS

#include <stdlib.h>          // General utilities
#include <string.h>          // String handling
#include <iostream.h>        // C++ input/output
#include <fstream.h>         // C++ file input/output
#include <stdio.h>

extern "C" { 
#include "PlugIns/GMP/gmp.h"
}
#include "BlackBox/Aux/bberror.h"  // Error constants

/*
extern "C" long random();
extern "C" char* initstate(unsigned int, char*,int);
extern "C" char* setstate(char *);
*/

#define BBDEFS_TRUE 1
#define BBDEFS_FALSE 0
#define BBDEFS_MAX(x,y) ((x>y)?x:y)
#define BBDEFS_MIN(x,y) ((x<y)?x:y)

// traceing hooks

#define BBDEFS_BBGCD_TRC
#define BBDEFS_BBSPARSE_TRC
#define BBDEFS_BBFACTOR_TRC
//#define BBDEFS_BBFACTOR_LIFT_TRC
//#define BBDEFS_BBFACTOR_HMAP_TRC
//#define BBDEFS_NUMDEN_TRC
//#define BBDEFS_DENSE_TRC
#define BBDEFS_BIDENSE_TRC
//#define BBDEFS_MPI_TRC
#define BBDEFS_SERVER_TRC

// black box file instance flags

#define BBDEFS_FACTOR_ID      10
#define BBDEFS_FACTOR_HMAP_ID 15
#define BBDEFS_GCD_ID         20
#define BBDEFS_NUMDEN_ID      30

// string sizes for I/O, mod conversion

#define BBDEFS_KSTRZ 10000
#define BBDEFS_PSTRZ 50000
#define BBDEFS_FILEZ 100

#endif

