
/*-------------------------------------------------------------
  module: bbmpidefs.h
  author: Angel L. Diaz

  date: 10/28/96

  description: 
     Definitions and includes common to all MPI compliant black box 
     library routines

  (c) Copyright 1996 Angel Diaz and Erich Kaltofen, All Rights Reserved
  This code is provided WITHOUT WARRANTY either expressed or implied.

-------------------------------------------------------------*/

#ifndef _BBDEFSMPI
#define _BBDEFSMPI

extern "C" {
#include "mpi.h"
}

// MPI interface upper bound constants

#define BBMPI_KSTRZ    500
#define BBMPI_FILESTRZ 50
#define BBMPI_MAXVAR   100

// MPI Server request menu

#define BBMPI_REQUEST        0
#define BBMPI_GCD            10 
#define BBMPI_GCD_STATIC     11
#define BBMPI_GCD_EVAL       12
#define BBMPI_GCD_ANS        13
#define BBMPI_FACTORS        20
#define BBMPI_FACTORS_STATIC 21
#define BBMPI_FACTORS_EVAL   22
#define BBMPI_FACTORS_ANS    23
#define BBMPI_NUMDEN         30
#define BBMPI_UPOLY          40
#define BBMPI_UPOLY_EVAL     41
#define BBMPI_UPOLY_STATIC   42
#define BBMPI_UPOLY_ANS      43
#define BBMPI_KILL           99

// MPI interface switches

#define BBMPI_DRIVER_RANK    0
#define BBMPI_CLOCK_ON       1
#define BBMPI_CLOCK_OFF      0

#endif
