
/*-------------------------------------------------------------
  module: bbtrace.h
  author: Angel L. Diaz

  date: 9/1/96

  desciption: 
     Generic tracing routines

  functions:
     OutputSingleItem
     OutputArray
     OutputArrayElm
     Output2DArrayElm
     OutputVec
     OutputVecVec

  (c) Copyright 1996 Angel Diaz and Erich Kaltofen, All Rights Reserved
  This code is provided WITHOUT WARRANTY either expressed or implied.
 

-------------------------------------------------------------*/

#ifndef _BBTRACE
#define _BBTRACE

template< class T > void OutputSingleItem(
   const char* Module_i,
   const char* Message_i,
   T& Elm_i
   )
{
   cout << Module_i << Message_i << Elm_i << endl;
}

template< class T > void OutputArray(
   const char* Module_i,
   const char* Description_i,
   const char* Message_i, 
   T* Array_i,
   int StartIndex_i,
   int EndIndex_i
   )
{
   int i;
   cout << Module_i << Description_i << endl;
   for( i=StartIndex_i; i<EndIndex_i; i++ )
       cout << Module_i << Message_i << i << "] = " << Array_i[i] 
            << endl;
}

template< class T > void OutputArrayElm(
   const char* Module_i,
   const char* Message_i,
   unsigned int i_i,
   T& Elm_i
   )
{
   cout << Module_i << Message_i << i_i << "] = " << Elm_i << endl;
}

template< class T > void Output2DArrayElm(
   const char* Module_i,
   const char* Message_i,
   unsigned int i_i,
   unsigned int j_i,
   T& Elm_i
   )
{
   cout << Module_i << Message_i << i_i << "][" << j_i << "] = " 
        << Elm_i << endl;
}

template< class T > void OutputVec(
   const  char* Module_i,
   const char* Description_i,
   const char* Message_i, 
   T& Array_i,
   int StartIndex_i,
   int EndIndex_i
   )
{
   int i;
   cout << Module_i << Description_i << endl;
   for( i=StartIndex_i; i<EndIndex_i; i++ )
       cout << Module_i << Message_i << i << "] = " << Array_i[i] 
            << endl;
}

template< class T > void OutputVecVec(
   const char* Module_i,
   const char* Description_i,
   const char* Message_i, 
   T& Elm_i,
   unsigned int r_i
   )
{
   unsigned int i,j;

   cout << Module_i << Description_i << endl;
   for( i=0; i<r_i; i++ ) {
      cout << Module_i << Message_i << i << "] = ";
      for( j=0; j<(Elm_i[i]).size(); j++ ) 
         cout << (Elm_i[i])[j] << " ";
      cout << endl;
   }
}

#endif
