/*===============================================
                 sacmacros.h

   Header file for SACLIB macro definitions
===============================================*/
#ifndef SACMACROS_H
#define SACMACROS_H

#include "sacsys.h"
#include "sactypes.h"


/* Macros which are always defined. */

#define FIRST(L)       SPACEB1[(L)]
#define RED(L)         SPACEB[(L)]
#define SFIRST(L,a)    (SPACEB1[(L)] = (a))
#define SRED(L,Lp)     (SPACEB[(L)] = (Lp))
#define ISNIL(a)       ((a) == NIL)
#define ISZERO(a)      ((a) == 0)
#define REM(a,b)       ((a) % (b))
#define GCASET(A,i,a)  (GCASPACEBp[(A)].array[(i)] = (a))
#define GCAGET(A,i)    (GCASPACEBp[(A)].array[(i)])


#ifndef NO_SACLIB_MACROS

/* List processing */

#define RED2(L)        RED(RED(L))
#define SECOND(L)      FIRST(RED(L))

/* Arithmetic */

#define ODD(a)         ((a) & 1)
#define DAND(a,b)      ((a) & (b))
#define DOR(a,b)       ((a) | (b))
#define DNOT(a)        (~(a))
#define DNIMP(a,b)     ((a) & ~(b))
#define MDSUM(m,a,b)  (((a)+(b))%(m))

/***
 *
 * The following macros give troubles w.r.t. side effects and therefore
 * are commented out for the time being.
 *
 ***/

/*
#define ISATOM(a)      (-BETA < (a) && (a) < BETA)
#define ISLIST(a)      (BETA <= (a) && (a) < BETAp && ((a) & 1))
#define ISOBJECT(a)    (ISATOM(a) || ISLIST(a))
#define ISGCA(a)       (BETAp < (a) && (a) < BETApp)
#define ADV(L,a,Lp)    do {*(a)=FIRST(L); *(Lp)=RED(L);} while (0)
#define QREM(a,b,q,r)  do {*(q)=(a)/(b); *(r)=(a)%(b);} while (0)
#define MDDIF(m,a,b)   (((a)-(b)+(m))%(m))
#define MDNEG(m,a)     ((a)==0?0:(m)-(a))
*/

#endif /* NO_SACLIB_MACROS */

#endif /* SACMACROS_H */
